<?php
// Use Google Authenticator with AppGini script by Phil Massyn
// For reference, see https://bigprof.com/appgini/help/advanced-topics/custom-limited-access-pages
//
//			  2019-11-17 - enabled self-removal of two factor auth for users. Olaf Nöhring, https://datenbank-projekt.de
//			  2019-11-19 - added app_title code. Olaf Nöhring, https://datenbank-projekt.de
//			  2019-11-19 - added localization (translation). Olaf Nöhring, https://datenbank-projekt.de
#
# How to use
# 1) Copy this script to your hooks folder
# 2) Create a link to this file in hooks/links-home.php and hooks/links-nav.php 
# 3) Update the menu path (see https://bigprof.com/appgini/help/advanced-topics/hooks/folder-contents )
#

/*
* To use the application title as title for your Google Authenticator Code, add the following lines of code directly after the opening PHP tag in your hooks/__global.php
* src: https://forums.appgini.com/phpbb/viewtopic.php?p=11496#p11496
*
//START add this code:
	$thisDir = dirname(__FILE__);
	$f_array=file("$thisDir/../membership_signup.php");
	$re = "/(?<=['\"\\(])[^\"()\\n']*?(?=[\\)\"'])/m"; 
	foreach ($f_array as $line_num => $line) {
		if (strpos($line,'app_name')) {
			preg_match_all($re, $line, $matches);
			$app_name=$matches[0][0];
			break;
		} 
	}
//END add this code:

*/

define('PREPEND_PATH', '../');
$hooks_dir = dirname(__FILE__);
include("$hooks_dir/../defaultLang.php");
include("$hooks_dir/../language.php");
include("$hooks_dir/../lib.php");
include_once("$hooks_dir/../header.php");

		//Language for Google Authenticator page - default
		include("$hooks_dir/GoogleAuthenticator_en.php");	
		//Language for Google Authenticator page - user language overwrites default
		include("$hooks_dir/GoogleAuthenticator_de.php");	

	/* START: grant access to all users who have access to the orders table / non guests */
	// you might need to remove this, if you do not have a table named 'totp_secrets' in yout AppGini application and given access to this to the users
	//	$user_can_access = get_sql_from('totp_secrets');
	//	if(!$user_can_access) exit(error_message('Access denied!', false));
	//alternate:
	//only allow access to this page for members
	if (getLoggedMemberID() == 'guest') exit(error_message('Access denied!', false));
	/* END: grant access to all users who have access to the orders table / non guests*/

require_once "$hooks_dir/GoogleAuthenticatorClass.php";
$ga = new framework_GoogleAuthenticator();
$conn = db_link();
$memberinfo = getMemberInfo();

$removeAuthSubmit = isset($_GET['removeAuthSubmit']) ? $removed = 1 : $removed = 0;
$removeAuth = isset($_GET['removeAuth']) ? makeSafe($_GET['removeAuth']) : 0;
if ($removeAuth == 1) {	
    $primary_key = getLoggedMemberID();
	$sql = "delete from totp_secrets where uid = '" . $primary_key . "';";
	$result = sqlValue($sql);
	echo '<h2>' . $ga_Translation['gaRemove'] . '</h2><p>' . $ga_Translation['gaRemovedCanRecreate'] . ' <a href="'. $_SERVER['PHP_SELF']  .'">Google Authenticator</a>.</p>';
}
else {
	echo '<h2>' . $ga_Translation['gaSetup'] . '</h2>';
if(!isset($_POST['secret']) && !isset($_POST['otp'])) {
		
		//you can use $host or, if you have your apptitle in a variable $app_title use this (like: https://forums.appgini.com/phpbb/viewtopic.php?f=2&t=3317&p=11511#p11511)
		if ($app_title <> "") {
			$use_title = $app_title;
		} else {
			$use_title = $host;
		}

		// this is the first page, to present the user with a QR code, and a form to validate the token
        echo $ga->TOTPsetupPage($memberinfo['username'],$use_title);	// need to find a way to retreive the site name and put it in here. you can use $host or, if you have your apptitle in a variable $app_title use this (like: https://forums.appgini.com/phpbb/viewtopic.php?f=2&t=3317&p=11511#p11511)
} elseif(isset($_POST['secret']) && isset($_POST['otp'])) {
	// now we check if the provided token is actually working
	$message = $ga->TOTPsetup($conn,$memberinfo['username']);
	if (preg_match("/ERROR/i", $message)) {
		echo '<div class="alert alert-warning"><i class="glyphicon glyphicon-warning-sign"></i> ';
		echo $message;
		echo '</div>';
		echo '<a href="setup_googleauth.php">' . $ga_Translation['TryAgain'] . '</a>';
	} else {
		echo '<div class="alert alert-success"><i class="glyphicon glyphicon-success-sign"></i> ';
		echo $message;
		echo '</div>';
}
}


?>
<h2><?php echo $ga_Translation['gaRemove'];?></h2>
<form action="<?php echo $_SERVER["PHP_SELF"]; ?>" method="get">
<div class="removeAuthCheckbox" title="<?php echo $ga_Translation['gaRemoveChkbxTitle']; ?>">
				<input type="checkbox" id="removeAuth" name="removeAuth" value="1">
				<label for="removeAuth"><?php echo $ga_Translation['gaRemoveChkbxLabel']; ?></label>
			</div><!-- removeAuthCheckbox -->

			<div class="removeAuthButton">
			<span class="btn-group btn-group-sm">
				<button id="removeAuthSubmit" name="removeAuthSubmit" value="1" type="submit" class="btn btn-danger delete" title="Submit"><?php echo $ga_Translation['gaRemoveBtnSubmit']; ?></button>
			</span>
		</div><!-- removeAuthButton -->
</form>			

<h2><?php echo $ga_Translation['gaSoftwareTitle']; ?></h2>
<div><p><?php echo $ga_Translation['gaSoftwareSuggestion']; ?></p></div>

<?php
}
include_once("$hooks_dir/../footer.php");
?>